<?php
namespace AngelicaO;
use vendor\Colors\RandomColor;

class SourceColorGenerator {

    private static $preferred_available_colors = array(//available colors, professionally chosen by designer. When they run out, generate random.
        '#7253A6',
        '#CF2B54',
        '#FFED00',
        '#6FEFF9',
        '#97CB1F',
        '#DEC6E0',
        '#F37178',
        '#F97A00',
        '#A9D697',
        '#5C94E8',
        '#ED5581',
        '#FFBA00',
        '#F02018',
        '#FFDDCE',
        '#00B2E2'
        //'#0644A2',
    );

    public function __construct() {
    }

    public static function generateColor() {
        $color = '#FFF';

        $result_used_colors = DB::query('SELECT UPPER(color) as `color` FROM devices', array());
        $used_colors = array();
        foreach ($result_used_colors as $used_color) {
            $used_colors[] = $used_color['color'];
        }

        $colors_available = array_diff(self::$preferred_available_colors, $used_colors);

        if (sizeof($colors_available) > 0) {
            $color = array_shift($colors_available);
        } else {
            $generatedColorCollision = false;//was this color generated before?

            do {
                $color = RandomColor::one(array(
                    'luminosity' => 'dark'
                ));

                $generatedColorCollision = in_array(strtoupper($color), $used_colors);
            } while ($generatedColorCollision === true);

        }

        return $color;
    }
}